=== debian/changelog ===
libtorrent-rasterbar (1.1.11-2) unstable; urgency=medium

  * d/rules: Use boost-python >=1.67 soname suffix to fix
    Python 3 linking (LP: #1800264).

 -- Calum Lind <calumlind@gmail.com>  Sat, 08 Dec 2018 21:49:08 -0500

libtorrent-rasterbar (1.1.11-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Remove ancient X-Python-Version field
  * d/control: Remove ancient X-Python3-Version field

  [ Ondřej Surý ]
  * New upstream version 1.1.11
  * Team upload.

 -- Ondřej Surý <ondrej@debian.org>  Sun, 02 Dec 2018 09:38:41 +0000
