## libtorrent-rasterbar 1.1.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(libtorrent
 	DESCRIPTION "Bittorrent library"
-	VERSION 1.1.11
+	VERSION 1.1.13
 )
 
 set (SOVERSION "9")
@@ -16,7 +16,6 @@
 	web_connection_base
 	alert
 	alert_manager
-	allocator
 	announce_entry
 	assert
 	bandwidth_limit
@@ -208,11 +207,11 @@
 target_compile_definitions(torrent-rasterbar
 	PUBLIC
 		$<$<CONFIG:Debug>:TORRENT_DEBUG>
+		BOOST_ASIO_ENABLE_CANCELIO
 	PRIVATE
 		TORRENT_BUILDING_LIBRARY
 		_FILE_OFFSET_BITS=64
 		BOOST_EXCEPTION_DISABLE
-		BOOST_ASIO_ENABLE_CANCELIO
 )
 
 target_include_directories(torrent-rasterbar
@@ -362,7 +361,11 @@
 	set (COMPILETIME_OPTIONS "${COMPILETIME_OPTIONS} -D${s}")
 endforeach (s)
 
-generate_and_install_pkg_config_file(torrent-rasterbar libtorrent-rasterbar)
+# There is little to none support for using pkg-config with MSVC and most users won't bother with it.
+# However, msys is a linux-like platform on Windows that do support/prefer using pkg-config.
+if (NOT MSVC)
+	generate_and_install_pkg_config_file(torrent-rasterbar libtorrent-rasterbar)
+endif()
 
 install(TARGETS torrent-rasterbar EXPORT LibtorrentRasterbarTargets
 	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
