=== debian/changelog ===
libtorrent-rasterbar (1.1.13-1~mx19+1) mx; urgency=medium

  * Rebuild for MX 19.
  * Disable dbg packages.
  * Add python-pygments to B-D to prevent FTBFS on Buster base.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 22 Jul 2019 18:07:37 -0700

libtorrent-rasterbar (1.1.13-1) unstable; urgency=medium

  * New upstream version 1.1.13
  * Team upload.

 -- Ondřej Surý <ondrej@sury.org>  Thu, 11 Jul 2019 09:18:04 +0200
