=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libtorrent-rasterbar
 Section: libs
 Priority: optional
-Maintainer: Cristian Greco <cristian@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Cristian Greco <cristian@debian.org>
 Uploaders: Andrew Starr-Bochicchio <asb@debian.org>
 Build-Depends: debhelper (>= 11),
                dh-python,
@@ -16,7 +17,8 @@
                python-docutils,
                python3-all-dev,
                python3-all-dbg,
-               python3-docutils
+               python3-docutils,
+               python-pygments
 Standards-Version: 4.1.4
 Vcs-Git: https://salsa.debian.org/debian/libtorrent-rasterbar.git
 Vcs-Browser: https://salsa.debian.org/debian/libtorrent-rasterbar/
@@ -59,22 +61,6 @@
  .
  This package contains header files and static version of the library.
 
-Package: libtorrent-rasterbar-dbg
-Section: debug
-Architecture: any
-Depends: ${misc:Depends}, libtorrent-rasterbar9 (= ${binary:Version})
-Description: Debug symbols for libtorrent-rasterbar
- Bittorrent library by Rasterbar Software (Arvid Norberg).
- libtorrent-rasterbar is a C++ library that aims to be a good alternative to
- all the other bittorrent implementations around.
- .
- The main goals of libtorrent-rasterbar are:
-  * to be cpu efficient
-  * to be memory efficient
-  * to be very easy to use
- .
- This package contains debugging symbols.
-
 Package: libtorrent-rasterbar-doc
 Section: doc
 Architecture: all
@@ -109,25 +95,6 @@
  .
  This package contains Python bindings for the libtorrent-rasterbar library.
 
-Package: python-libtorrent-dbg
-Section: debug
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-libtorrent (= ${binary:Version}), python-dbg
-Provides: ${python:Provides}
-Breaks: ${python:Breaks}
-Description: Python bindings for libtorrent-rasterbar (debug symbols)
- Bittorrent library by Rasterbar Software (Arvid Norberg).
- libtorrent-rasterbar is a C++ library that aims to be a good alternative to
- all the other bittorrent implementations around.
- .
- The main goals of libtorrent-rasterbar are:
-  * to be cpu efficient
-  * to be memory efficient
-  * to be very easy to use
- .
- This package contains Python bindings for the libtorrent-rasterbar library
- (debug symbols).
-
 Package: python3-libtorrent
 Section: python
 Architecture: any
@@ -143,20 +110,3 @@
   * to be very easy to use
  .
  This package contains Python 3 bindings for the libtorrent-rasterbar library.
-
-Package: python3-libtorrent-dbg
-Section: debug
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-libtorrent (= ${binary:Version}), python3-dbg
-Description: Python bindings for libtorrent-rasterbar (debug symbols) (Python 3)
- Bittorrent library by Rasterbar Software (Arvid Norberg).
- libtorrent-rasterbar is a C++ library that aims to be a good alternative to
- all the other bittorrent implementations around.
- .
- The main goals of libtorrent-rasterbar are:
-  * to be cpu efficient
-  * to be memory efficient
-  * to be very easy to use
- .
- This package contains Python 3 bindings for the libtorrent-rasterbar library
- (debug symbols).
