=== debian/rules ===
--- 
+++ 
@@ -60,7 +60,7 @@
 	dh_compress -Xcpp
 
 override_dh_strip:
-	dh_strip --dbg-package=libtorrent-rasterbar-dbg
+	dh_strip --no-automatic-dbgsym
 
 override_dh_makeshlibs:
 	dh_makeshlibs -V
